'****************************************************************************
'*                                                                          *
'*  Declarations of Windows DLL AVPCL32.DLL for Visual Basic                *
'*                                                                          *
'*  Copyright (c) 1995-2023 by PLURA Europe GmbH                            *
'*                                                                          *
'****************************************************************************

' $Id: avpcl32.vb 2123 2023-10-05 14:32:37Z J.Loh $
' Version: 5.45

' For documentation see avpcl.h

'****************************************************************************

Public Module AvPcl32

    '****************************************************************************

    Public Const PCL_VER_DLL = &H500 + 45 ' 5.45

    '****************************************************************************

    Public Const PCL_OK = 0
    Public Const PCL_NO_NEWD = 1
    Public Const PCL_ERR_INV_PORT = -1
    Public Const PCL_ERR_NOT_FOUND = -2
    Public Const PCL_ERR_NO_HANDLE = -3
    Public Const PCL_ERR_INV_HDL = -4
    Public Const PCL_ERR_NOTOPEN = -5
    Public Const PCL_ERR_NULL = -6
    Public Const PCL_ERR_TIMEOUT = -7
    Public Const PCL_ERR_INV_REG = -8
    Public Const PCL_ERR_INV_BANK = -9
    Public Const PCL_ERR_RANGE = -10
    Public Const PCL_ERR_INIT = -11
    Public Const PCL_ERR_IOCTL = -12
    Public Const PCL_ERR_VER = -13
    Public Const PCL_ERR_NOT_SUPP = -14
    Public Const PCL_ERR_UK_CMD = -15
    Public Const PCL_ERR_OPEN = -16

    '****************************************************************************

    Public Const PCL_HANDLES = 10

    Public Const PCL_REQ_ASYN = &H80
    Public Const PCL_REQ_SYNC = &H40
    Public Const PCL_REQ_PERM = &H20

    '****************************************************************************

    Declare Function pclOpen Lib "AVPCL32" (ByRef hdl As Integer, ByVal base As Integer) As Integer

    Public Const PCL_BASE_PCI_OFS = &H1000
    Public Const PCL_BASE_PCI_1 = &H1001
    Public Const PCL_BASE_PCI_2 = &H1002
    Public Const PCL_BASE_PCI_3 = &H1003
    Public Const PCL_BASE_PCI_4 = &H1004
    Public Const PCL_BASE_PCI_5 = &H1005
    Public Const PCL_BASE_PCI_6 = &H1006
    Public Const PCL_BASE_PCI_7 = &H1007
    Public Const PCL_BASE_PCI_8 = &H1008
    Public Const PCL_BASE_PCI_9 = &H1009
    Public Const PCL_BASE_PCI_10 = &H100A
    Public Const PCL_BASE_PCI_LAST = &H100A

    Public Const PCL_BASE_0 = &H200
    Public Const PCL_BASE_1 = &H220
    Public Const PCL_BASE_2 = &H240
    Public Const PCL_BASE_FACTORY = &H240
    Public Const PCL_BASE_3 = &H260
    Public Const PCL_BASE_4 = &H280
    Public Const PCL_BASE_5 = &H2A0
    Public Const PCL_BASE_6 = &H2C0
    Public Const PCL_BASE_7 = &H2E0
    Public Const PCL_BASE_8 = &H300
    Public Const PCL_BASE_9 = &H320
    Public Const PCL_BASE_A = &H340
    Public Const PCL_BASE_B = &H360
    Public Const PCL_BASE_C = &H380
    Public Const PCL_BASE_D = &H3A0
    Public Const PCL_BASE_E = &H3C0
    Public Const PCL_BASE_F = &H3E0

    '****************************************************************************

    Declare Function pclClose Lib "AVPCL32" (ByVal hdl As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetTc Lib "AVPCL32" (ByVal hdl As Integer, ByRef time As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetUser Lib "AVPCL32" (ByVal hdl As Integer, ByRef user As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetRegister Lib "AVPCL32" (ByVal hdl As Integer, ByVal reg As Integer, ByRef time As Integer, ByRef bits As Integer, ByRef user As Integer, ByRef frame As Integer, ByRef newd As Integer) As Integer

    Public Const PCL_REG_MIXED = &H0
    Public Const PCL_REG_CTL = &H1
    Public Const PCL_REG_LTC = &H2
    Public Const PCL_REG_VITC = &H3
    Public Const PCL_REG_MIXED2 = &H4
    Public Const PCL_REG_CTL2 = &H5
    Public Const PCL_REG_LTC2 = &H6
    Public Const PCL_REG_VITC2 = &H7
    Public Const PCL_REG_EVENT = &H8
    Public Const PCL_REG_EVENT2 = &H9
    Public Const PCL_REG_TRAN = &HA
    Public Const PCL_REG_STATUS = &HB
    Public Const PCL_REG_IO = &HC
    Public Const PCL_REG_SERIN = &HD
    Public Const PCL_REG_SHIFT = &HE
    Public Const PCL_REG_CMD = &HF
    Public Const PCL_REG_BANK = &H10

    Public Const PCL_FRAME_24 = &H24
    Public Const PCL_FRAME_25 = &H25
    Public Const PCL_FRAME_30 = &H30
    Public Const PCL_FRAME_30DF = &HB0

    Public Const PCL_BITS_CTL_SIGN = &H40
    Public Const PCL_BITS_CTL_DIR = &H80
    Public Const PCL_BITS_LTC_10 = &H1
    Public Const PCL_BITS_LTC_DROP = &H1
    Public Const PCL_BITS_LTC_11 = &H2
    Public Const PCL_BITS_LTC_CF = &H2
    Public Const PCL_BITS_LTC_27 = &H4
    Public Const PCL_BITS_LTC_43 = &H8
    Public Const PCL_BITS_LTC_58 = &H10
    Public Const PCL_BITS_LTC_59 = &H20
    Public Const PCL_BITS_LTC_WHEEL = &H40
    Public Const PCL_BITS_LTC_DIR = &H80

    Public Const PCL_BITS_VITC_14 = &H1
    Public Const PCL_BITS_VITC_DROP = &H1
    Public Const PCL_BITS_VITC_15 = &H2
    Public Const PCL_BITS_VITC_CF = &H2
    Public Const PCL_BITS_VITC_35 = &H4
    Public Const PCL_BITS_VITC_NF = &H4
    Public Const PCL_BITS_VITC_55 = &H8
    Public Const PCL_BITS_VITC_74 = &H10
    Public Const PCL_BITS_VITC_75 = &H20
    Public Const PCL_BITS_VITC_PF = &H20
    Public Const PCL_BITS_VITC_WHEEL = &H40

    Public Const PCL_NEWD_NONE = &H0
    Public Const PCL_NEWD_VITC = &H80
    Public Const PCL_NEWD_LTC = &H40
    Public Const PCL_NEWD_CTL = &H20

    '****************************************************************************

    Declare Function pclGetRegSync Lib "AVPCL32" (ByVal hdl As Integer, ByVal reg As Integer, ByRef time As Integer, ByRef bits As Integer, ByRef user As Integer, ByRef frame As Integer, ByRef newd As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetVersion Lib "AVPCL32" (ByVal hdl As Integer, ByRef ident As Integer, ByRef firmware As Integer, ByRef dll As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetVerSpecial Lib "AVPCL32" (ByVal hdl As Integer, ByRef ident1 As Integer, ByRef ident2 As Integer, ByRef ident3 As Integer) As Integer

    '****************************************************************************

    Declare Function pclReset Lib "AVPCL32" (ByVal hdl As Integer, ByVal imode As Integer) As Integer

    Public Const PCL_IMODE_NORMAL = &H0
    Public Const PCL_IMODE_SONY9S = &H1
    Public Const PCL_IMODE_JVC9S = &H2
    Public Const PCL_IMODE_JVC45 = &H3
    Public Const PCL_IMODE_PANA34 = &H4
    Public Const PCL_IMODE_PANA25 = &H5
    Public Const PCL_IMODE_SONY9 = &H6
    Public Const PCL_IMODE_JVC9 = &H7
    Public Const PCL_IMODE_SONY33 = &H8
    Public Const PCL_IMODE_JVC25 = &H9
    Public Const PCL_IMODE_TEST = &HF0

    '****************************************************************************

    Declare Function pclIntMask Lib "AVPCL32" (ByVal hdl As Integer, ByVal imask As Integer) As Integer

    Public Const PCL_IMASK_NONE = &H0
    Public Const PCL_IMASK_MIXED = &H1
    Public Const PCL_IMASK_LTC = &H4
    Public Const PCL_IMASK_VITC = &H8
    Public Const PCL_IMASK_V1 = &H40
    Public Const PCL_IMASK_V2 = &H80

    Public Const PCL_IMASK_ATC_LTC = &H100
    Public Const PCL_IMASK_ATC_VITC = &H200
    Public Const PCL_IMASK_HANC_LTC = &H800 ' obsolete
    Public Const PCL_IMASK_HANC_VITC = &H1000 ' obsolete

    Public Const PCL_IMASK_ATC_VITC1 = &H200 ' obsolete
    Public Const PCL_IMASK_ATC_VITC2 = &H400 ' obsolete

    '****************************************************************************

    Declare Function pclSetIntMask Lib "AVPCL32" (ByVal hdl As Integer, ByVal imask As Integer) As Integer

    '****************************************************************************

    Declare Function pclResetIntMask Lib "AVPCL32" (ByVal hdl As Integer, ByVal imask As Integer) As Integer

    '****************************************************************************

    Public Structure PCL_INT_RESULT
        Public counter As Integer
        Public lost As Integer
        Public stopped As Boolean
    End Structure

    '****************************************************************************

    Delegate Sub PCL_INT_HANDLER(ByVal hdl As Integer, ByRef intResult As PCL_INT_RESULT)

    '****************************************************************************

    Declare Function pclReaderEnable Lib "AVPCL32" (ByVal hdl As Integer, ByVal rmask As Integer) As Integer

    Public Const PCL_RMASK_NONE = &H0
    Public Const PCL_RMASK_CTL = &H1
    Public Const PCL_RMASK_LTC = &H2
    Public Const PCL_RMASK_VITC = &H4
    Public Const PCL_RMASK_ATC_LTC = &H100
    Public Const PCL_RMASK_ATC_VITC1 = &H200
    Public Const PCL_RMASK_ATC_VITC2 = &H400
    Public Const PCL_RMASK_HANC_LTC = &H800
    Public Const PCL_RMASK_HANC_VITC = &H1000
    Public Const PCL_RMASK_ALL = &H1F06

    '****************************************************************************

    Declare Function pclVitcSetup Lib "AVPCL32" (ByVal hdl As Integer, ByVal line1 As Integer, ByVal line2 As Integer, ByVal vline As Integer) As Integer

    Public Const PCL_VLINE_2LINES = &H0
    Public Const PCL_VLINE_BLOCK = &H1

    '****************************************************************************

    Declare Function pclMixedEnable Lib "AVPCL32" (ByVal hdl As Integer, ByVal rmask As Integer) As Integer

    '****************************************************************************

    Declare Function pclPriority Lib "AVPCL32" (ByVal hdl As Integer, ByVal prior As Integer) As Integer

    Public Const PCL_PRIOR_VLC = &H1
    Public Const PCL_PRIOR_LVC = &H2

    '****************************************************************************

    Declare Function pclTcFrames Lib "AVPCL32" (ByVal hdl As Integer, ByVal tcfr As Integer) As Integer

    Public Const PCL_TCFR_AUTO = &H0
    Public Const PCL_TCFR_24 = &H1
    Public Const PCL_TCFR_25 = &H2
    Public Const PCL_TCFR_30 = &H3
    Public Const PCL_TCFR_30DF = &H4

    '****************************************************************************

    Public Declare Function pclLtcFrames Lib "AVPCL32" (ByVal hdl As Integer, ByVal ltcfr As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclVitcFrames Lib "AVPCL32" (ByVal hdl As Integer, ByVal vitcfr As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclVitcLevelControl Lib "AVPCL32" (ByVal hdl As Integer, ByVal vlmode As Integer, ByVal vlev As Integer, ByRef vlret As Integer) As Integer

    Public Const PCL_VLMODE_AUTO = &H0
    Public Const PCL_VLMODE_AUTO_SET = &H1
    Public Const PCL_VLMODE_AUTO_INIT = &H2
    Public Const PCL_VLMODE_OFF = &H3
    Public Const PCL_VLMODE_OFF_SET = &H4

    Public Const PCL_VLEV_MIN = &H0
    Public Const PCL_VLEV_MAX = &H45

    '****************************************************************************

    Public Declare Function pclLtcError Lib "AVPCL32" (ByVal hdl As Integer, ByVal ecmode As Integer, ByRef ecval As Integer) As Integer

    Public Const PCL_ECMODE_GET_RESET = &H0
    Public Const PCL_ECMODE_GET = &H1

    '****************************************************************************

    Public Declare Function pclVitcError Lib "AVPCL32" (ByVal hdl As Integer, ByVal ecmode As Integer, ByRef ecval As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclFlyWheel Lib "AVPCL32" (ByVal hdl As Integer, ByVal fwmode As Integer) As Integer

    Public Const PCL_FWMODE_OFF = &H0
    Public Const PCL_FWMODE_LTC = &H2
    Public Const PCL_FWMODE_VITC = &H4
    Public Const PCL_FWMODE_ALL = &H6

    '****************************************************************************

    Public Declare Function pclAtcLtcError Lib "AVPCL32" (ByVal hdl As Integer, ByVal ecmode As Integer, ByRef ecval As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclAtcVitc1Error Lib "AVPCL32" (ByVal hdl As Integer, ByVal ecmode As Integer, ByRef ecval As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclAtcVitc2Error Lib "AVPCL32" (ByVal hdl As Integer, ByVal ecmode As Integer, ByRef ecval As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclHancLtcError Lib "AVPCL32" (ByVal hdl As Integer, ByVal ecmode As Integer, ByRef ecval As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclHancVitcError Lib "AVPCL32" (ByVal hdl As Integer, ByVal ecmode As Integer, ByRef ecval As Integer) As Integer

    '****************************************************************************

    Public Declare Function pclGetVideoStandard Lib "AVPCL32" (ByVal hdl As Integer, ByRef system As Integer, ByRef progressive As Integer) As Integer

    Public Const PCL_VSYSTEM_UNKNOWN = 0
    Public Const PCL_VSYSTEM_625I_25 = 1
    Public Const PCL_VSYSTEM_525I_29 = 2
    Public Const PCL_VSYSTEM_1080I_25 = 3
    Public Const PCL_VSYSTEM_1080I_29 = 4
    Public Const PCL_VSYSTEM_1080I_24 = 5
    Public Const PCL_VSYSTEM_720P_50 = 6
    Public Const PCL_VSYSTEM_720P_59 = 7
    Public Const PCL_VSYSTEM_1080P_25 = 8
    Public Const PCL_VSYSTEM_1080P_29 = 9
    Public Const PCL_VSYSTEM_1080P_24 = 10
    Public Const PCL_VSYSTEM_720P_24 = 11
    Public Const PCL_VSYSTEM_720P_25 = 12
    Public Const PCL_VSYSTEM_720P_29 = 13
    Public Const PCL_VSYSTEM_1035I_29 = 14

    '****************************************************************************

    Declare Function pclTc2Bcd Lib "AVPCL32" (ByVal hours As Integer, ByVal minutes As Integer, ByVal seconds As Integer, ByVal frames As Integer) As Integer

    '****************************************************************************

    Declare Function pclBcd2Tc Lib "AVPCL32" (ByVal time As Integer, ByRef hours As Integer, ByRef minutes As Integer, ByRef seconds As Integer, ByRef frames As Integer) As Integer

    '****************************************************************************

    Declare Function pclTc2Frames Lib "AVPCL32" (ByVal time As Integer, ByVal frate As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetErrorString Lib "AVPCL32" () As String

    '****************************************************************************

    Declare Function pclSetIntHandler Lib "AVPCL32" (ByVal hdl As Integer, ByVal intHandler As PCL_INT_HANDLER) As Integer

    '****************************************************************************
    '*                                                                          *
    '* Obsolete Functions                                                       *
    '*                                                                          *
    '****************************************************************************

    ' The following declaration are only for backward campatibility to the
    ' ISA version 2.xx of the DLL.  With this PCI version 3.xx, any of these
    ' function will return PCL_ERR_NOT_SUPP.

    '****************************************************************************

    Declare Function pclGetBaseAddress Lib "AVPCL32" (ByVal index As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetEvent Lib "AVPCL32" (ByVal hdl As Integer, ByRef dist1 As Integer, ByRef dist2 As Integer, ByRef dist3 As Integer, ByRef evtc As Integer, ByRef evub As Integer, ByRef eflg As Integer) As Integer

    Public Const PCL_EVTC_FRU = &H1
    Public Const PCL_EVTC_FRT = &H2
    Public Const PCL_EVTC_SEU = &H4
    Public Const PCL_EVTC_SET = &H8
    Public Const PCL_EVTC_MIN = &H10
    Public Const PCL_EVTC_HOU = &H20
    Public Const PCL_EVTC_SIG12 = &H40
    Public Const PCL_EVTC_SIG = &H80

    Public Const PCL_EVUB_UB1 = &H1
    Public Const PCL_EVUB_UB2 = &H2
    Public Const PCL_EVUB_UB3 = &H4
    Public Const PCL_EVUB_UB4 = &H8
    Public Const PCL_EVUB_UB5 = &H10
    Public Const PCL_EVUB_UB6 = &H20
    Public Const PCL_EVUB_UB7 = &H40
    Public Const PCL_EVUB_UB8 = &H80

    Public Const PCL_EFLG_UMASK = &HF
    Public Const PCL_EFLG_TMASK = &HF0

    '****************************************************************************

    Declare Function pclGetTransfer Lib "AVPCL32" (ByVal hdl As Integer, ByRef tran() As Byte) As Integer

    '****************************************************************************

    Declare Function pclGetIo Lib "AVPCL32" (ByVal hdl As Integer, ByRef oprt As Integer, ByRef ana As Integer, ByRef iprt As Integer) As Integer

    Public Const PCL_OPRT_1 = &H1
    Public Const PCL_OPRT_2 = &H2
    Public Const PCL_OPRT_3 = &H4
    Public Const PCL_OPRT_4 = &H8
    Public Const PCL_OPRT_5 = &H10
    Public Const PCL_OPRT_6 = &H20
    Public Const PCL_OPRT_7 = &H40
    Public Const PCL_OPRT_8 = &H80
    Public Const PCL_OPRT_9 = &H100
    Public Const PCL_OPRT_10 = &H200
    Public Const PCL_OPRT_11 = &H400
    Public Const PCL_OPRT_12 = &H800
    Public Const PCL_OPRT_13 = &H1000
    Public Const PCL_OPRT_14 = &H2000
    Public Const PCL_OPRT_15 = &H4000
    Public Const PCL_OPRT_16 = &H8000
    Public Const PCL_OPRT_17 = &H10000
    Public Const PCL_OPRT_18 = &H20000
    Public Const PCL_OPRT_19 = &H40000
    Public Const PCL_OPRT_20 = &H80000
    Public Const PCL_OPRT_21 = &H100000
    Public Const PCL_OPRT_22 = &H200000
    Public Const PCL_OPRT_23 = &H400000
    Public Const PCL_OPRT_24 = &H800000

    Public Const PCL_IPRT_1 = &H1
    Public Const PCL_IPRT_2 = &H2
    Public Const PCL_IPRT_3 = &H4
    Public Const PCL_IPRT_4 = &H8
    Public Const PCL_IPRT_5 = &H10
    Public Const PCL_IPRT_6 = &H20
    Public Const PCL_IPRT_7 = &H40
    Public Const PCL_IPRT_8 = &H80
    Public Const PCL_IPRT_9 = &H100
    Public Const PCL_IPRT_10 = &H200
    Public Const PCL_IPRT_11 = &H400
    Public Const PCL_IPRT_12 = &H800
    Public Const PCL_IPRT_13 = &H1000
    Public Const PCL_IPRT_14 = &H2000
    Public Const PCL_IPRT_15 = &H4000

    '****************************************************************************

    Declare Function pclSioCmd Lib "AVPCL32" (ByVal hdl As Integer, ByVal scmd As Integer) As Integer

    Public Const PCL_SCMD_RDIS = &H0
    Public Const PCL_SCMD_RENA = &H1
    Public Const PCL_SCMD_NONE = &H0
    Public Const PCL_SCMD_ODD = &H20
    Public Const PCL_SCMD_EVEN = &H60
    Public Const PCL_SCMD_MARK = &HA0
    Public Const PCL_SCMD_SPACE = &HE0

    '****************************************************************************

    Declare Function pclSioCtl Lib "AVPCL32" (ByVal hdl As Integer, ByVal sctl As Integer) As Integer

    Public Const PCL_SCTL_38400 = &H0
    Public Const PCL_SCTL_50 = &H1
    Public Const PCL_SCTL_75 = &H2
    Public Const PCL_SCTL_110 = &H3
    Public Const PCL_SCTL_135 = &H4
    Public Const PCL_SCTL_150 = &H5
    Public Const PCL_SCTL_300 = &H6
    Public Const PCL_SCTL_600 = &H7
    Public Const PCL_SCTL_1200 = &H8
    Public Const PCL_SCTL_1800 = &H9
    Public Const PCL_SCTL_2400 = &HA
    Public Const PCL_SCTL_3600 = &HB
    Public Const PCL_SCTL_4800 = &HC
    Public Const PCL_SCTL_7200 = &HD
    Public Const PCL_SCTL_9600 = &HE
    Public Const PCL_SCTL_19200 = &HF
    Public Const PCL_SCTL_RS232 = &H0
    Public Const PCL_SCTL_RS422 = &H10
    Public Const PCL_SCTL_B8 = &H0
    Public Const PCL_SCTL_B7 = &H20
    Public Const PCL_SCTL_B6 = &H40
    Public Const PCL_SCTL_B5 = &H60
    Public Const PCL_SCTL_S1 = &H0
    Public Const PCL_SCTL_S2 = &H80

    '****************************************************************************

    Declare Function pclGetSio Lib "AVPCL32" (ByVal hdl As Integer, ByRef ssta As Integer, ByRef scmd As Integer, ByRef sctl As Integer) As Integer

    Public Const PCL_SSTA_PARITY = &H1
    Public Const PCL_SSTA_FRAMING = &H2
    Public Const PCL_SSTA_OVERRUN = &H4
    Public Const PCL_SSTA_RFULL = &H8
    Public Const PCL_SSTA_TEMPTY = &H10
    Public Const PCL_SSTA_RS232 = &H0
    Public Const PCL_SSTA_RS422 = &H20
    Public Const PCL_SSTA_DSR = &H40
    Public Const PCL_SSTA_IRQ = &H80

    '****************************************************************************

    Declare Function pclGetTrans Lib "AVPCL32" (ByVal hdl As Integer, ByRef strf As Integer) As Integer

    '****************************************************************************

    Declare Function pclResetTrans Lib "AVPCL32" (ByVal hdl As Integer) As Integer

    '****************************************************************************

    Declare Function pclGetSerIn Lib "AVPCL32" (ByVal hdl As Integer, ByRef sind() As Byte, ByRef srcv As Integer, ByRef count As Integer) As Integer

    Public Const PCL_SRCV_PARITY = &H1
    Public Const PCL_SRCV_FRAMING = &H2
    Public Const PCL_SRCV_OVERRUN = &H4
    Public Const PCL_SRCV_IBUFOV = &H8
    Public Const PCL_SRCV_MBUFOV = &H10

    '****************************************************************************

    Declare Function pclGetShift Lib "AVPCL32" (ByVal hdl As Integer, ByRef shou As Integer, ByRef shin As Integer, ByRef shst As Integer) As Integer

    Public Const PCL_SHST_INEWD = &H1
    Public Const PCL_SHST_OENA = &H80

    '****************************************************************************

    Declare Function pclRawCommand Lib "AVPCL32" (ByVal hdl As Integer, ByVal cmd As Integer, ByRef cdat() As Byte) As Integer

    '****************************************************************************

    Declare Function pclDataReq Lib "AVPCL32" (ByVal hdl As Integer, ByVal reg As Integer) As Integer

    '****************************************************************************

    Declare Function pclCtlRate Lib "AVPCL32" (ByVal hdl As Integer, ByVal ctlrate As Integer) As Integer

    '****************************************************************************

    Declare Function pclCtlCount Lib "AVPCL32" (ByVal hdl As Integer, ByVal frps As Integer) As Integer

    '****************************************************************************

    Declare Function pclCtlMode Lib "AVPCL32" (ByVal hdl As Integer, ByVal cmode As Integer) As Integer

    Public Const PCL_CMODE_UNSIGNED = &H0
    Public Const PCL_CMODE_SIGNED = &H1

    '****************************************************************************

    Declare Function pclCtlReset Lib "AVPCL32" (ByVal hdl As Integer) As Integer

    '****************************************************************************

    Declare Function pclCtlPreset Lib "AVPCL32" (ByVal hdl As Integer, ByVal time As Integer) As Integer

    '****************************************************************************

    Declare Function pclCtlDir Lib "AVPCL32" (ByVal hdl As Integer, ByVal cdir As Integer) As Integer

    Public Const PCL_CDIR_REV = &H0
    Public Const PCL_CDIR_FWD = &H1

    '****************************************************************************

    Declare Function pclEventTime Lib "AVPCL32" (ByVal hdl As Integer, ByVal time As Integer) As Integer

    '****************************************************************************

    Declare Function pclEventUser Lib "AVPCL32" (ByVal hdl As Integer, ByVal user As Integer) As Integer

    '****************************************************************************

    Declare Function pclTranBank Lib "AVPCL32" (ByVal hdl As Integer, ByVal bank As Integer, ByRef tstr() As Byte) As Integer

    '****************************************************************************

    Declare Function pclRecMode Lib "AVPCL32" (ByVal hdl As Integer, ByVal rmode As Integer) As Integer

    Public Const PCL_RMODE_NORMAL = &H0
    Public Const PCL_RMODE_SONY = &H1
    Public Const PCL_RMODE_PANA = &H0

    '****************************************************************************

    Declare Function pclTranStr Lib "AVPCL32" (ByVal hdl As Integer, ByVal num As Integer) As Integer

    '****************************************************************************

    Declare Function pclTranData Lib "AVPCL32" (ByVal hdl As Integer, ByVal num As Integer, ByRef tdat() As Byte) As Integer

    '****************************************************************************

    Declare Function pclModeOut Lib "AVPCL32" (ByVal hdl As Integer, ByVal omode As Integer, ByVal freq As Integer) As Integer

    Public Const PCL_OMODE_NORMAL = &H0
    Public Const PCL_OMODE_FREQ = &H1

    '****************************************************************************

    Declare Function pclOutPort Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer) As Integer

    '****************************************************************************

    Declare Function pclPortHigh Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer) As Integer

    '****************************************************************************

    Declare Function pclPortLow Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer) As Integer

    '****************************************************************************

    Declare Function pclPosPulse Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer, ByVal pmode As Integer, ByVal pwidth As Integer) As Integer

    Public Const PCL_PMODE_INDIV = &H0
    Public Const PCL_PMODE_SAME = &H1

    '****************************************************************************

    Declare Function pclNegPulse Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer, ByVal pmode As Integer, ByVal pwidth As Integer) As Integer

    '****************************************************************************

    Declare Function pclPosPulseOut Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer, ByVal pwidth As Integer) As Integer

    '****************************************************************************

    Declare Function pclNegPulseOut Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer, ByVal pwidth As Integer) As Integer

    '****************************************************************************

    Declare Function pclPulseWidth Lib "AVPCL32" (ByVal hdl As Integer, ByVal oprt As Integer, ByVal pwidth As Integer) As Integer

    '****************************************************************************

    Declare Function pclAnalogOut Lib "AVPCL32" (ByVal hdl As Integer, ByVal value As Integer) As Integer

    '****************************************************************************

    Declare Function pclShiftData Lib "AVPCL32" (ByVal hdl As Integer, ByVal shou As Integer) As Integer

    '****************************************************************************

    Declare Function pclShiftWidth Lib "AVPCL32" (ByVal hdl As Integer, ByVal swid As Integer) As Integer

    Public Const PCL_SWID_8 = &H0
    Public Const PCL_SWID_16 = &H1
    Public Const PCL_SWID_24 = &H2
    Public Const PCL_SWID_32 = &H3

    '****************************************************************************

    Declare Function pclShiftMode Lib "AVPCL32" (ByVal hdl As Integer, ByVal smod As Integer) As Integer

    Public Const PCL_SMODE_DIS = &H80
    Public Const PCL_SMODE_ONE = &H0
    Public Const PCL_SMODE_CONT = &H1

    '****************************************************************************

    Declare Function pclRecCtl Lib "AVPCL32" (ByVal hdl As Integer, ByVal rctl As Integer) As Integer

    Public Const PCL_RCTL_STOP = &H1
    Public Const PCL_RCTL_PLAY = &H2
    Public Const PCL_RCTL_REC = &H3
    Public Const PCL_RCTL_STILL = &H4
    Public Const PCL_RCTL_FFWD = &H5
    Public Const PCL_RCTL_ADV = &H6
    Public Const PCL_RCTL_FREV = &H7
    Public Const PCL_RCTL_BACK = &H8
    Public Const PCL_RCTL_TRIMF = &H10
    Public Const PCL_RCTL_TRIMR = &H11
    Public Const PCL_RCTL_EJECT = &H21
    Public Const PCL_RCTL_EDON = &H24
    Public Const PCL_RCTL_EDOFF = &H25

    '****************************************************************************

    Declare Function pclRecCtlData Lib "AVPCL32" (ByVal hdl As Integer, ByVal rctl As Integer, ByVal data As Integer) As Integer

    Public Const PCL_RCTD_VFWD = &H12
    Public Const PCL_RCTD_VREV = &H13
    Public Const PCL_RCTD_JFWD = &H14
    Public Const PCL_RCTD_JREV = &H15
    Public Const PCL_RCTD_SFWD = &H1F
    Public Const PCL_RCTD_SREV = &H20
    Public Const PCL_RCTD_EDPR = &H26

    Public Const PCL_EDPR_AUDIO1 = &H1
    Public Const PCL_EDPR_AUDIO2 = &H2
    Public Const PCL_EDPR_AUDIO3 = &H4
    Public Const PCL_EDPR_TIMECODE = &H4
    Public Const PCL_EDPR_AUDIO4 = &H8
    Public Const PCL_EDPR_VIDEO = &H10
    Public Const PCL_EDPR_ASSEMBLE = &H20
    Public Const PCL_EDPR_INSERT = &H40

    '****************************************************************************

    Declare Function pclRecCtlTc Lib "AVPCL32" (ByVal hdl As Integer, ByVal rctl As Integer, ByVal time As Integer) As Integer

    Public Const PCL_RCTC_CUEUP = &H16
    Public Const PCL_RCTC_GOTO = &H16

    '****************************************************************************

    Declare Function pclRecStat Lib "AVPCL32" (ByVal hdl As Integer, ByRef stat() As Byte, ByRef ident As Integer) As Integer

    '****************************************************************************

    Declare Function pclIoctlError Lib "AVPCL32" () As Integer

    '****************************************************************************

    Declare Function pclLtcSequence Lib "AVPCL32" (ByVal hdl As Integer, ByVal lseq As Integer) As Integer

    Public Const PCL_LSEQ_CHECK = &H0
    Public Const PCL_LSEQ_NOCHECK = &H1

    '****************************************************************************

    Declare Function pclReaderSource Lib "AVPCL32" (ByVal hdl As Integer, ByVal rsrc As Integer) As Integer

    Public Const PCL_RSRC_1 = &H1
    Public Const PCL_RSRC_2 = &H2

    '****************************************************************************

    Declare Function pclSetMixed Lib "AVPCL32" (ByVal hdl As Integer, ByVal time As Integer, ByVal user As Integer, ByVal status As Integer, ByVal newd As Integer) As Integer

    '****************************************************************************

    Declare Function pclOptGetcmd Lib "AVPCL32" (ByVal hdl As Integer, ByRef rctl As Integer, ByRef full() As Byte) As Integer

    Public Const PCL_RCTF_STATS = &HEF
    Public Const PCL_RCTF_NONE = &HFE
    Public Const PCL_RCTF_UNKNOWN = &HFF

    '****************************************************************************

End Module
