﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Collections;

namespace AvPcl
{
    public class Dll
    {
        //###############################################################
        #region DLL-Imports
        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclOpen(out int hdl, UInt32 baseAddr);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclClose(int hdl);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetTc(int hdl, out UInt32 time);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetUser(int hdl, out UInt32 user);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetRegister(int hdl, int reg,
                out UInt32 time, out int bits, out UInt32 user,
                out int frame, out int newd);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetRegSync(int hdl, int reg,
                out UInt32 time, out int bits, out UInt32 user,
                out int frame, out int newd);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetRegStatus(int hdl, int reg, out int stat);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetVersion(int hdl, out int ident,
            out int firmware, out int dll);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetVerSpecial(int hdl,
            out int ident1, out int ident2, out int ident3);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclReset(int hdl, int iMode);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclIntMask(int hdl, int imask);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclSetIntMask(int hdl, int imask);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclResetIntMask(int hdl, int imask);

        [StructLayout(LayoutKind.Sequential)]
        public class PclIntResult
        {
            public UInt32 counter;
            public UInt32 lost;
            public Byte stopped;
        };

        // Delegate to be called by this wrapper class
//      public delegate void AvIntDelegate(int hdl, int flag, PclIntResult intResult);

        // Delegate to be called by the unmanaged dll
        [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
        public delegate void AvIntDelegate(int hdl, int flag, PclIntResult result);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        // Import of the unmanaged function that registers the callback function
        private static extern int pclSetIntHandler(int hdl, AvIntDelegate del);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclSetIntPriority(int hdl, int priority);

//      [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
//      public static extern int pclGetThreadHandle(int hdl, int thread,
//          out IntPtr handle);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclReaderEnable(int hdl, int rmask);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclVitcSetup(int hdl,
            int line1, int line2, int vline);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclMixedEnable(int hdl, int rmask);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclPriority(int hdl, int prior);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclTcFrames(int hdl, int tcfr);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclLtcFrames(int hdl, int ltcfr);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclVitcFrames(int hdl, int vitcfr);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclVitcLevelControl(int hdl, int vlmode, int vlev,
            out IntPtr vlret);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclLtcSequence(int hdl, int lseq);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclLtcError(int hdl, int ecmode,
            out IntPtr ecval);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclVitcError(int hdl, int ecmode,
            out IntPtr ecval);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclFlyWheel(int hdl, int fwmode);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclAtcLtcError(int hdl, int ecmode,
            out IntPtr ecval);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclAtcVitc1Error(int hdl, int ecmode,
            out IntPtr ecval);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclAtcVitc2Error(int hdl, int ecmode,
            out IntPtr ecval);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclHancLtcError(int hdl, int ecmode,
            out IntPtr ecval);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclHancVitcError(int hdl, int ecmode,
            out IntPtr progressive);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclSetDID(int hdl, int ancreg, int did);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclSetSDID(int hdl, int ancreg, int sdid);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetVideoStandard(int hdl,
            out IntPtr system, out IntPtr progressive);

        [DllImport("avpcl32.dll", CharSet = CharSet.Auto)]
        public static extern int pclGetVideoRaster(int hdl,
            out IntPtr activeWords, out IntPtr totalWords,
            out IntPtr activeLines, out IntPtr totalLines);

        #endregion


        //###############################################################
        #region Fields

        public static int PCL_VER4_DLL = 0x0500 + 45; // 5.45
        public static int PCL_VER_DLL = PCL_VER4_DLL;

        #endregion

        //###############################################################
        #region Members
        private static Hashtable m_RegisteredDelegates = new Hashtable(5);
        #endregion

        //###############################################################
        #region Interrupt

        private static AvIntDelegate m_Deleg;

        /// <summary>Register Interrupt Handler</summary>
        /// <param name="del">
        /// Delegate to be called upon interrupt event
        /// </param>
        public static int SetIntHandler(int hdl, AvIntDelegate del)
        {
            m_Deleg = new AvIntDelegate(DelegateWrapper);
            int ret = pclSetIntHandler(hdl, m_Deleg);
            if (m_RegisteredDelegates.ContainsKey(hdl))
                m_RegisteredDelegates.Remove(hdl);
            m_RegisteredDelegates.Add(hdl, del);
            return ret;
        }

//      private static void DelegateWrapper(int hdl, int flag, [MarshalAs(UnmanagedType.LPStruct)] PclIntResult result)
        private static void DelegateWrapper(int hdl, int flag, PclIntResult result)
        {
            if (m_RegisteredDelegates.ContainsKey(hdl))
            {
                ((AvIntDelegate)m_RegisteredDelegates[hdl])(hdl, flag, result);
            }
        }

        #endregion

    }
}
