﻿using System;
using System.Collections.Generic;
using System.Text;

namespace AvPcl
{
    public class Timecode
    {
        private int h, m, s, f;

        //####################################################
        #region Bcd
        UInt16 Bcd2Hex(UInt16 bcd)
		{
            return  (UInt16)((bcd & 0x000F) +
	                (((bcd & 0x00F0) >>  4) *   10) +
	                (((bcd & 0x0F00) >>  8) *  100) +
	                (((bcd & 0xF000) >> 12) * 1000));
        }
        #endregion

        //####################################################
        #region Overrides
        override public string ToString()
        {
            return String.Format("{0:00}:{1:00}:{2:00}:{3:00}",
                H, M, S, F
                );
        }
        #endregion

        //####################################################
        #region Get/Set
        public void SetBcd(UInt32 bcdTc)
        {
            H = Bcd2Hex((UInt16)(bcdTc >> 6 * 4));
            M = Bcd2Hex((UInt16)((bcdTc >> 4 * 4) & 0xFF));
            S = Bcd2Hex((UInt16)((bcdTc >> 2 * 4) & 0xFF));
            F = Bcd2Hex((UInt16)((bcdTc) & 0xFF));
        }
        #endregion

        //####################################################
        #region Properties
        public int H
        {
            get { return h; }
            set { h = value; }
        }

        public int M
        {
            get { return m; }
            set { m = value; }
        }

        public int S
        {
            get { return s; }
            set { s = value; }
        }

        public int F
        {
            get { return f; }
            set { f = value; }
        }
        #endregion
    }
}
