/***************************************************************************\
*																			*
*	Linux Kernel Driver for PCL PCI(e) Devices								*
*																			*
*	Copyright (c) 1995-2023 by PLURA Europe GmbH							*
*																			*
\***************************************************************************/

// $Id: params.h 2123 2023-10-05 14:32:37Z J.Loh $

//---------------------------------------------------------------------------

#define AVPCL_VER     5
#define AVPCL_VER_S  "5"

#define AVPCL_SUB    45		// Version 5.45
#define AVPCL_SUB_S "45"	// Version 5.45

#define VER_LEGAL_COPYRIGHT "(c) PLURA Europe GmbH 1995-2023\0"

//---------------------------------------------------------------------------

#ifdef LINUX
#define PCL_USE_SHM_MUTEX 				// use shared memory mutex for 
										// concurrent access
//#define PCL_USE_SYSV_SEM				// use System V semaphores for
										// concurrent access

#if defined(PCL_USE_SHM_MUTEX) && defined(PCL_USE_SYSV_SEM)
#error Cannot use both methods at once.
#endif

//---------------------------------------------------------------------------

// Options of the Linux Driver

#define PCL_TIMEOUT 40					// timeout in millisekunden
#define PCL_OPT_GETCMD					// get command bytes from device
//#define PCL_OPT_MTD					// read mtd times
#define PCL_OPT_REALTIME				// pcl as real-time source
#define PCL_OPT_FLASH					// include functions to support
										// pcl flash updates

//---------------------------------------------------------------------------

#define _PCL_EXTERN extern
#define _PCL_CONST  const

#endif // LINUX

//---------------------------------------------------------------------------
